ocrText = Metadata.Values("OCRTEXT")

'Variables contain the regular expressions that will be use to look for the required information, will need to be modified when more combinations may occur
Dim Target, Target2
Dim matchedValue, numLin, numVar, nameVar, nameVarColl
Dim arrLines

Target = ".*()\$*(CODICE ARTICOLO DESCRIZIONE)"
Target2 = ".*()\$*(Pagina 1)"

arrLines = Split(ocrText, vbCrLf)

call Metadata.SetValues("OCR_LINE", "## NOT FOUND ##")
call Metadata.SetValues("OCR_LINE_WITHOUT_CODICE", "## NOT FOUND ##")
call Metadata.SetValues("OCR_LINE_COLLI", "## NOT FOUND ##")
call Metadata.SetValues("OCR_LINE_VOLUME", "## NOT FOUND ##")
call Metadata.SetValues("NUM_LINE", "0")
call Metadata.SetValues("NUM_COLLI", "0")

numLin = 0
numVar = -1
numColl = 0

'Then you can iterate it like this 
For Each strline in arrLines
	numLin = numLin + 1
	call Application.Log(99,numLin)
	If numVar < 0 Then
		match = GetFirstMatch(target, strline)
		If match <> "" Then 
			numVar = numVar + 1
			call Application.Log(99,"START TABLE")
		End If
	Else
		matchFinal = GetFirstMatch(target2, strline)
		If matchFinal <> "" Then
			call Application.Log(99,"END TABLE")
			Exit For
		Else
			If(InStr(arrLines(numLin), "NR") <> 0 OR InStr(arrLines(numLin), "PZ") <> 0 ) then
				numVar = numVar + 1
				call Application.Log(99,"FOUND LINE")
				nameVar = "OCR_LINE_" & CStr(numVar)
				call Application.Log(99,nameVar)
				call Metadata.SetValues(nameVar, arrLines(numLin))
				call Metadata.SetValues("NUM_LINE", numVar)
				
			ElseIf(InStr(arrLines(numLin), "SACCHETTO") <> 0) then
				numColl = numColl + 1
				call Application.Log(99,"FOUND COLLI")
				nameVarColl = "OCR_LINE_COLLI_" & CStr(numColl)
				call Metadata.SetValues(nameVarColl, Replace(arrLines(numLin),"Distinta Colli: ",""))
				call Metadata.SetValues("NUM_COLLI", numColl)
			
			ElseIf(InStr(arrLines(numLin), "VOLUME") <> 0) then
				call Application.Log(99,"FOUND VOLUME")
				call Metadata.SetValues("OCR_LINE_VOLUME", Replace(arrLines(numLin),"VOLUME ",""))
			
			Else
				descr = descr & "_" & arrLines(numLin)
				call Metadata.SetValues("OCR_LINE_WITHOUT_CODICE", descr)
			End If	
		End If
	End If
Next

' Get the first objRE  submatch from the string
' Returns empty string if not found, otherwise returns the matched string
Function GetFirstMatch(PatternToMatch, StringToSearch)
	Dim objRE , CurrentMatch, objMatch

	Set objRE  = New RegExp
	objRE.Pattern = PatternToMatch
	objRE.IgnoreCase = True
	objRE.Global = False

	Set objMatch = objRE.Execute(StringToSearch)
	
	GetFirstMatch = ""
	' We should get only 1 match since the Global property is FALSE
	If objMatch.Count = 1 Then
		' Item(0) is the (first and only) matching target parts,
		' Submatches(1) is the substring between the second set of
		' parentheses (all indexes are zero based)
		GetFirstMatch = objMatch.Item(0).Submatches(1)
	End If
	Set objRE  = Nothing
End Function
